/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x010709, CODE_FOR_extendqisi2 },
  { 0x01070a, CODE_FOR_extendqidi2 },
  { 0x010809, CODE_FOR_extendhisi2 },
  { 0x01080a, CODE_FOR_extendhidi2 },
  { 0x01090a, CODE_FOR_extendsidi2 },
  { 0x010a0b, CODE_FOR_extendditi2 },
  { 0x011f20, CODE_FOR_extendsfdf2 },
  { 0x011f21, CODE_FOR_extendsfkf2 },
  { 0x011f22, CODE_FOR_extendsftf2 },
  { 0x011f23, CODE_FOR_extendsfif2 },
  { 0x012021, CODE_FOR_extenddfkf2 },
  { 0x012022, CODE_FOR_extenddftf2 },
  { 0x012023, CODE_FOR_extenddfif2 },
  { 0x012122, CODE_FOR_extendkftf2 },
  { 0x012221, CODE_FOR_extendtfkf2 },
  { 0x012223, CODE_FOR_extendtfif2 },
  { 0x012321, CODE_FOR_extendifkf2 },
  { 0x012322, CODE_FOR_extendiftf2 },
  { 0x012425, CODE_FOR_extendsddd2 },
  { 0x012426, CODE_FOR_extendsdtd2 },
  { 0x012526, CODE_FOR_extendddtd2 },
  { 0x02201f, CODE_FOR_truncdfsf2 },
  { 0x02211f, CODE_FOR_trunckfsf2 },
  { 0x022120, CODE_FOR_trunckfdf2 },
  { 0x022122, CODE_FOR_trunckftf2 },
  { 0x02221f, CODE_FOR_trunctfsf2 },
  { 0x022220, CODE_FOR_trunctfdf2 },
  { 0x022221, CODE_FOR_trunctfkf2 },
  { 0x022223, CODE_FOR_trunctfif2 },
  { 0x02231f, CODE_FOR_truncifsf2 },
  { 0x022320, CODE_FOR_truncifdf2 },
  { 0x022321, CODE_FOR_truncifkf2 },
  { 0x022322, CODE_FOR_trunciftf2 },
  { 0x022524, CODE_FOR_truncddsd2 },
  { 0x022624, CODE_FOR_trunctdsd2 },
  { 0x022625, CODE_FOR_trunctddd2 },
  { 0x030709, CODE_FOR_zero_extendqisi2 },
  { 0x03070a, CODE_FOR_zero_extendqidi2 },
  { 0x030809, CODE_FOR_zero_extendhisi2 },
  { 0x03080a, CODE_FOR_zero_extendhidi2 },
  { 0x03090a, CODE_FOR_zero_extendsidi2 },
  { 0x04250a, CODE_FOR_fixdddi2 },
  { 0x04260a, CODE_FOR_fixtddi2 },
  { 0x04260b, CODE_FOR_fixtdti2 },
  { 0x06071f, CODE_FOR_floatqisf2 },
  { 0x060720, CODE_FOR_floatqidf2 },
  { 0x060721, CODE_FOR_floatqikf2 },
  { 0x060722, CODE_FOR_floatqitf2 },
  { 0x06081f, CODE_FOR_floathisf2 },
  { 0x060820, CODE_FOR_floathidf2 },
  { 0x060821, CODE_FOR_floathikf2 },
  { 0x060822, CODE_FOR_floathitf2 },
  { 0x06091f, CODE_FOR_floatsisf2 },
  { 0x060920, CODE_FOR_floatsidf2 },
  { 0x060921, CODE_FOR_floatsikf2 },
  { 0x060922, CODE_FOR_floatsitf2 },
  { 0x060923, CODE_FOR_floatsiif2 },
  { 0x060a1f, CODE_FOR_floatdisf2 },
  { 0x060a20, CODE_FOR_floatdidf2 },
  { 0x060a21, CODE_FOR_floatdikf2 },
  { 0x060a22, CODE_FOR_floatditf2 },
  { 0x060a25, CODE_FOR_floatdidd2 },
  { 0x060a26, CODE_FOR_floatditd2 },
  { 0x060b21, CODE_FOR_floattikf2 },
  { 0x060b22, CODE_FOR_floattitf2 },
  { 0x060b26, CODE_FOR_floattitd2 },
  { 0x06353e, CODE_FOR_floatv4siv4sf2 },
  { 0x06363f, CODE_FOR_floatv2div2df2 },
  { 0x07071f, CODE_FOR_floatunsqisf2 },
  { 0x070720, CODE_FOR_floatunsqidf2 },
  { 0x070721, CODE_FOR_floatunsqikf2 },
  { 0x070722, CODE_FOR_floatunsqitf2 },
  { 0x07081f, CODE_FOR_floatunshisf2 },
  { 0x070820, CODE_FOR_floatunshidf2 },
  { 0x070821, CODE_FOR_floatunshikf2 },
  { 0x070822, CODE_FOR_floatunshitf2 },
  { 0x07091f, CODE_FOR_floatunssisf2 },
  { 0x070920, CODE_FOR_floatunssidf2 },
  { 0x070a1f, CODE_FOR_floatunsdisf2 },
  { 0x070a20, CODE_FOR_floatunsdidf2 },
  { 0x070a21, CODE_FOR_floatunsdikf2 },
  { 0x070a22, CODE_FOR_floatunsditf2 },
  { 0x070b21, CODE_FOR_floatunstikf2 },
  { 0x070b22, CODE_FOR_floatunstitf2 },
  { 0x07353e, CODE_FOR_floatunsv4siv4sf2 },
  { 0x07363f, CODE_FOR_floatunsv2div2df2 },
  { 0x081f0a, CODE_FOR_lrintsfdi2 },
  { 0x08200a, CODE_FOR_lrintdfdi2 },
  { 0x091f0a, CODE_FOR_lroundsfdi2 },
  { 0x09200a, CODE_FOR_lrounddfdi2 },
  { 0x101f07, CODE_FOR_fix_truncsfqi2 },
  { 0x101f08, CODE_FOR_fix_truncsfhi2 },
  { 0x101f09, CODE_FOR_fix_truncsfsi2 },
  { 0x101f0a, CODE_FOR_fix_truncsfdi2 },
  { 0x102007, CODE_FOR_fix_truncdfqi2 },
  { 0x102008, CODE_FOR_fix_truncdfhi2 },
  { 0x102009, CODE_FOR_fix_truncdfsi2 },
  { 0x10200a, CODE_FOR_fix_truncdfdi2 },
  { 0x102107, CODE_FOR_fix_trunckfqi2 },
  { 0x102108, CODE_FOR_fix_trunckfhi2 },
  { 0x102109, CODE_FOR_fix_trunckfsi2 },
  { 0x10210a, CODE_FOR_fix_trunckfdi2 },
  { 0x10210b, CODE_FOR_fix_trunckfti2 },
  { 0x102207, CODE_FOR_fix_trunctfqi2 },
  { 0x102208, CODE_FOR_fix_trunctfhi2 },
  { 0x102209, CODE_FOR_fix_trunctfsi2 },
  { 0x10220a, CODE_FOR_fix_trunctfdi2 },
  { 0x10220b, CODE_FOR_fix_trunctfti2 },
  { 0x102309, CODE_FOR_fix_truncifsi2 },
  { 0x103e35, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x103f36, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x111f07, CODE_FOR_fixuns_truncsfqi2 },
  { 0x111f08, CODE_FOR_fixuns_truncsfhi2 },
  { 0x111f09, CODE_FOR_fixuns_truncsfsi2 },
  { 0x111f0a, CODE_FOR_fixuns_truncsfdi2 },
  { 0x112007, CODE_FOR_fixuns_truncdfqi2 },
  { 0x112008, CODE_FOR_fixuns_truncdfhi2 },
  { 0x112009, CODE_FOR_fixuns_truncdfsi2 },
  { 0x11200a, CODE_FOR_fixuns_truncdfdi2 },
  { 0x112107, CODE_FOR_fixuns_trunckfqi2 },
  { 0x112108, CODE_FOR_fixuns_trunckfhi2 },
  { 0x112109, CODE_FOR_fixuns_trunckfsi2 },
  { 0x11210a, CODE_FOR_fixuns_trunckfdi2 },
  { 0x11210b, CODE_FOR_fixuns_trunckfti2 },
  { 0x112207, CODE_FOR_fixuns_trunctfqi2 },
  { 0x112208, CODE_FOR_fixuns_trunctfhi2 },
  { 0x112209, CODE_FOR_fixuns_trunctfsi2 },
  { 0x11220a, CODE_FOR_fixuns_trunctfdi2 },
  { 0x11220b, CODE_FOR_fixuns_trunctfti2 },
  { 0x113e35, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x113f36, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x12090a, CODE_FOR_mulsidi3 },
  { 0x120a0b, CODE_FOR_mulditi3 },
  { 0x13090a, CODE_FOR_umulsidi3 },
  { 0x130a0b, CODE_FOR_umulditi3 },
  { 0x213333, CODE_FOR_vcondv16qiv16qi },
  { 0x213434, CODE_FOR_vcondv8hiv8hi },
  { 0x213535, CODE_FOR_vcondv4siv4si },
  { 0x21353e, CODE_FOR_vcondv4sfv4si },
  { 0x213636, CODE_FOR_vcondv2div2di },
  { 0x21363f, CODE_FOR_vcondv2dfv2di },
  { 0x213e35, CODE_FOR_vcondv4siv4sf },
  { 0x213e3e, CODE_FOR_vcondv4sfv4sf },
  { 0x213f36, CODE_FOR_vcondv2div2df },
  { 0x213f3f, CODE_FOR_vcondv2dfv2df },
  { 0x223333, CODE_FOR_vconduv16qiv16qi },
  { 0x223434, CODE_FOR_vconduv8hiv8hi },
  { 0x223535, CODE_FOR_vconduv4siv4si },
  { 0x22353e, CODE_FOR_vconduv4sfv4si },
  { 0x223636, CODE_FOR_vconduv2div2di },
  { 0x22363f, CODE_FOR_vconduv2dfv2di },
  { 0x243333, CODE_FOR_vcond_mask_v16qiv16qi },
  { 0x243434, CODE_FOR_vcond_mask_v8hiv8hi },
  { 0x243535, CODE_FOR_vcond_mask_v4siv4si },
  { 0x24353e, CODE_FOR_vcond_mask_v4sfv4si },
  { 0x243636, CODE_FOR_vcond_mask_v2div2di },
  { 0x24363f, CODE_FOR_vcond_mask_v2dfv2di },
  { 0x253333, CODE_FOR_vec_cmpv16qiv16qi },
  { 0x253434, CODE_FOR_vec_cmpv8hiv8hi },
  { 0x253535, CODE_FOR_vec_cmpv4siv4si },
  { 0x25353e, CODE_FOR_vec_cmpv4sfv4si },
  { 0x253636, CODE_FOR_vec_cmpv2div2di },
  { 0x25363f, CODE_FOR_vec_cmpv2dfv2di },
  { 0x263333, CODE_FOR_vec_cmpuv16qiv16qi },
  { 0x263434, CODE_FOR_vec_cmpuv8hiv8hi },
  { 0x263535, CODE_FOR_vec_cmpuv4siv4si },
  { 0x263636, CODE_FOR_vec_cmpuv2div2di },
  { 0x2e0733, CODE_FOR_vec_extractv16qiqi },
  { 0x2e0834, CODE_FOR_vec_extractv8hihi },
  { 0x2e0935, CODE_FOR_vec_extractv4sisi },
  { 0x2e0a36, CODE_FOR_vec_extractv2didi },
  { 0x2e1f3e, CODE_FOR_vec_extractv4sfsf },
  { 0x2e203f, CODE_FOR_vec_extractv2dfdf },
  { 0x2f0733, CODE_FOR_vec_initv16qiqi },
  { 0x2f0834, CODE_FOR_vec_initv8hihi },
  { 0x2f0935, CODE_FOR_vec_initv4sisi },
  { 0x2f0a36, CODE_FOR_vec_initv2didi },
  { 0x2f1f3e, CODE_FOR_vec_initv4sfsf },
  { 0x2f203f, CODE_FOR_vec_initv2dfdf },
  { 0x310009, CODE_FOR_addsi3 },
  { 0x31000a, CODE_FOR_adddi3 },
  { 0x31000b, CODE_FOR_addti3 },
  { 0x31001f, CODE_FOR_addsf3 },
  { 0x310020, CODE_FOR_adddf3 },
  { 0x310021, CODE_FOR_addkf3 },
  { 0x310022, CODE_FOR_addtf3 },
  { 0x310025, CODE_FOR_adddd3 },
  { 0x310026, CODE_FOR_addtd3 },
  { 0x310033, CODE_FOR_addv16qi3 },
  { 0x310034, CODE_FOR_addv8hi3 },
  { 0x310035, CODE_FOR_addv4si3 },
  { 0x310036, CODE_FOR_addv2di3 },
  { 0x31003e, CODE_FOR_addv4sf3 },
  { 0x31003f, CODE_FOR_addv2df3 },
  { 0x350009, CODE_FOR_subsi3 },
  { 0x35000a, CODE_FOR_subdi3 },
  { 0x35000b, CODE_FOR_subti3 },
  { 0x35001f, CODE_FOR_subsf3 },
  { 0x350020, CODE_FOR_subdf3 },
  { 0x350021, CODE_FOR_subkf3 },
  { 0x350022, CODE_FOR_subtf3 },
  { 0x350025, CODE_FOR_subdd3 },
  { 0x350026, CODE_FOR_subtd3 },
  { 0x350033, CODE_FOR_subv16qi3 },
  { 0x350034, CODE_FOR_subv8hi3 },
  { 0x350035, CODE_FOR_subv4si3 },
  { 0x350036, CODE_FOR_subv2di3 },
  { 0x35003e, CODE_FOR_subv4sf3 },
  { 0x35003f, CODE_FOR_subv2df3 },
  { 0x390009, CODE_FOR_mulsi3 },
  { 0x39000a, CODE_FOR_muldi3 },
  { 0x39001f, CODE_FOR_mulsf3 },
  { 0x390020, CODE_FOR_muldf3 },
  { 0x390021, CODE_FOR_mulkf3 },
  { 0x390022, CODE_FOR_multf3 },
  { 0x390025, CODE_FOR_muldd3 },
  { 0x390026, CODE_FOR_multd3 },
  { 0x390033, CODE_FOR_mulv16qi3 },
  { 0x390034, CODE_FOR_mulv8hi3 },
  { 0x390035, CODE_FOR_mulv4si3 },
  { 0x390036, CODE_FOR_mulv2di3 },
  { 0x39003e, CODE_FOR_mulv4sf3 },
  { 0x39003f, CODE_FOR_mulv2df3 },
  { 0x3d0009, CODE_FOR_divsi3 },
  { 0x3d000a, CODE_FOR_divdi3 },
  { 0x3d000b, CODE_FOR_divti3 },
  { 0x3d001f, CODE_FOR_divsf3 },
  { 0x3d0020, CODE_FOR_divdf3 },
  { 0x3d0021, CODE_FOR_divkf3 },
  { 0x3d0022, CODE_FOR_divtf3 },
  { 0x3d0025, CODE_FOR_divdd3 },
  { 0x3d0026, CODE_FOR_divtd3 },
  { 0x3d0035, CODE_FOR_divv4si3 },
  { 0x3d0036, CODE_FOR_divv2di3 },
  { 0x3d003e, CODE_FOR_divv4sf3 },
  { 0x3d003f, CODE_FOR_divv2df3 },
  { 0x400009, CODE_FOR_udivsi3 },
  { 0x40000a, CODE_FOR_udivdi3 },
  { 0x40000b, CODE_FOR_udivti3 },
  { 0x400035, CODE_FOR_udivv4si3 },
  { 0x400036, CODE_FOR_udivv2di3 },
  { 0x440009, CODE_FOR_modsi3 },
  { 0x44000a, CODE_FOR_moddi3 },
  { 0x44000b, CODE_FOR_modti3 },
  { 0x440035, CODE_FOR_modv4si3 },
  { 0x440036, CODE_FOR_modv2di3 },
  { 0x450009, CODE_FOR_umodsi3 },
  { 0x45000a, CODE_FOR_umoddi3 },
  { 0x45000b, CODE_FOR_umodti3 },
  { 0x450035, CODE_FOR_umodv4si3 },
  { 0x450036, CODE_FOR_umodv2di3 },
  { 0x460025, CODE_FOR_ftruncdd2 },
  { 0x460026, CODE_FOR_ftrunctd2 },
  { 0x46003e, CODE_FOR_ftruncv4sf2 },
  { 0x46003f, CODE_FOR_ftruncv2df2 },
  { 0x470009, CODE_FOR_andsi3 },
  { 0x47000a, CODE_FOR_anddi3 },
  { 0x47000b, CODE_FOR_andti3 },
  { 0x47000c, CODE_FOR_andpti3 },
  { 0x47002b, CODE_FOR_andcpti3 },
  { 0x47002c, CODE_FOR_andcti3 },
  { 0x470033, CODE_FOR_andv16qi3 },
  { 0x470034, CODE_FOR_andv8hi3 },
  { 0x470035, CODE_FOR_andv4si3 },
  { 0x470036, CODE_FOR_andv2di3 },
  { 0x470037, CODE_FOR_andv1ti3 },
  { 0x47003e, CODE_FOR_andv4sf3 },
  { 0x47003f, CODE_FOR_andv2df3 },
  { 0x480009, CODE_FOR_iorsi3 },
  { 0x48000a, CODE_FOR_iordi3 },
  { 0x48000b, CODE_FOR_iorti3 },
  { 0x48000c, CODE_FOR_iorpti3 },
  { 0x480033, CODE_FOR_iorv16qi3 },
  { 0x480034, CODE_FOR_iorv8hi3 },
  { 0x480035, CODE_FOR_iorv4si3 },
  { 0x480036, CODE_FOR_iorv2di3 },
  { 0x480037, CODE_FOR_iorv1ti3 },
  { 0x48003e, CODE_FOR_iorv4sf3 },
  { 0x48003f, CODE_FOR_iorv2df3 },
  { 0x490009, CODE_FOR_xorsi3 },
  { 0x49000a, CODE_FOR_xordi3 },
  { 0x49000b, CODE_FOR_xorti3 },
  { 0x49000c, CODE_FOR_xorpti3 },
  { 0x490033, CODE_FOR_xorv16qi3 },
  { 0x490034, CODE_FOR_xorv8hi3 },
  { 0x490035, CODE_FOR_xorv4si3 },
  { 0x490036, CODE_FOR_xorv2di3 },
  { 0x490037, CODE_FOR_xorv1ti3 },
  { 0x49003e, CODE_FOR_xorv4sf3 },
  { 0x49003f, CODE_FOR_xorv2df3 },
  { 0x4a0009, CODE_FOR_ashlsi3 },
  { 0x4a000a, CODE_FOR_ashldi3 },
  { 0x4d0009, CODE_FOR_ashrsi3 },
  { 0x4d000a, CODE_FOR_ashrdi3 },
  { 0x4e0009, CODE_FOR_lshrsi3 },
  { 0x4e000a, CODE_FOR_lshrdi3 },
  { 0x4f0009, CODE_FOR_rotlsi3 },
  { 0x4f000a, CODE_FOR_rotldi3 },
  { 0x51000b, CODE_FOR_vashlti3 },
  { 0x510033, CODE_FOR_vashlv16qi3 },
  { 0x510034, CODE_FOR_vashlv8hi3 },
  { 0x510035, CODE_FOR_vashlv4si3 },
  { 0x510036, CODE_FOR_vashlv2di3 },
  { 0x510037, CODE_FOR_vashlv1ti3 },
  { 0x520033, CODE_FOR_vashrv16qi3 },
  { 0x520034, CODE_FOR_vashrv8hi3 },
  { 0x520035, CODE_FOR_vashrv4si3 },
  { 0x520036, CODE_FOR_vashrv2di3 },
  { 0x520037, CODE_FOR_vashrv1ti3 },
  { 0x53000b, CODE_FOR_vlshrti3 },
  { 0x530033, CODE_FOR_vlshrv16qi3 },
  { 0x530034, CODE_FOR_vlshrv8hi3 },
  { 0x530035, CODE_FOR_vlshrv4si3 },
  { 0x530036, CODE_FOR_vlshrv2di3 },
  { 0x530037, CODE_FOR_vlshrv1ti3 },
  { 0x540033, CODE_FOR_vrotlv16qi3 },
  { 0x540034, CODE_FOR_vrotlv8hi3 },
  { 0x540035, CODE_FOR_vrotlv4si3 },
  { 0x540036, CODE_FOR_vrotlv2di3 },
  { 0x540037, CODE_FOR_vrotlv1ti3 },
  { 0x550033, CODE_FOR_vrotrv16qi3 },
  { 0x550034, CODE_FOR_vrotrv8hi3 },
  { 0x550035, CODE_FOR_vrotrv4si3 },
  { 0x550036, CODE_FOR_vrotrv2di3 },
  { 0x56001f, CODE_FOR_sminsf3 },
  { 0x560020, CODE_FOR_smindf3 },
  { 0x560021, CODE_FOR_sminkf3 },
  { 0x560022, CODE_FOR_smintf3 },
  { 0x560033, CODE_FOR_sminv16qi3 },
  { 0x560034, CODE_FOR_sminv8hi3 },
  { 0x560035, CODE_FOR_sminv4si3 },
  { 0x560036, CODE_FOR_sminv2di3 },
  { 0x56003e, CODE_FOR_sminv4sf3 },
  { 0x56003f, CODE_FOR_sminv2df3 },
  { 0x57001f, CODE_FOR_smaxsf3 },
  { 0x570020, CODE_FOR_smaxdf3 },
  { 0x570021, CODE_FOR_smaxkf3 },
  { 0x570022, CODE_FOR_smaxtf3 },
  { 0x570033, CODE_FOR_smaxv16qi3 },
  { 0x570034, CODE_FOR_smaxv8hi3 },
  { 0x570035, CODE_FOR_smaxv4si3 },
  { 0x570036, CODE_FOR_smaxv2di3 },
  { 0x57003e, CODE_FOR_smaxv4sf3 },
  { 0x57003f, CODE_FOR_smaxv2df3 },
  { 0x580033, CODE_FOR_uminv16qi3 },
  { 0x580034, CODE_FOR_uminv8hi3 },
  { 0x580035, CODE_FOR_uminv4si3 },
  { 0x580036, CODE_FOR_uminv2di3 },
  { 0x590033, CODE_FOR_umaxv16qi3 },
  { 0x590034, CODE_FOR_umaxv8hi3 },
  { 0x590035, CODE_FOR_umaxv4si3 },
  { 0x590036, CODE_FOR_umaxv2di3 },
  { 0x5a0009, CODE_FOR_negsi2 },
  { 0x5a000a, CODE_FOR_negdi2 },
  { 0x5a001f, CODE_FOR_negsf2 },
  { 0x5a0020, CODE_FOR_negdf2 },
  { 0x5a0021, CODE_FOR_negkf2 },
  { 0x5a0022, CODE_FOR_negtf2 },
  { 0x5a0023, CODE_FOR_negif2 },
  { 0x5a0025, CODE_FOR_negdd2 },
  { 0x5a0026, CODE_FOR_negtd2 },
  { 0x5a0033, CODE_FOR_negv16qi2 },
  { 0x5a0034, CODE_FOR_negv8hi2 },
  { 0x5a0035, CODE_FOR_negv4si2 },
  { 0x5a0036, CODE_FOR_negv2di2 },
  { 0x5a003e, CODE_FOR_negv4sf2 },
  { 0x5a003f, CODE_FOR_negv2df2 },
  { 0x5e001f, CODE_FOR_abssf2 },
  { 0x5e0020, CODE_FOR_absdf2 },
  { 0x5e0021, CODE_FOR_abskf2 },
  { 0x5e0022, CODE_FOR_abstf2 },
  { 0x5e0023, CODE_FOR_absif2 },
  { 0x5e0025, CODE_FOR_absdd2 },
  { 0x5e0026, CODE_FOR_abstd2 },
  { 0x5e0033, CODE_FOR_absv16qi2 },
  { 0x5e0034, CODE_FOR_absv8hi2 },
  { 0x5e0035, CODE_FOR_absv4si2 },
  { 0x5e0036, CODE_FOR_absv2di2 },
  { 0x5e003e, CODE_FOR_absv4sf2 },
  { 0x5e003f, CODE_FOR_absv2df2 },
  { 0x600009, CODE_FOR_one_cmplsi2 },
  { 0x60000a, CODE_FOR_one_cmpldi2 },
  { 0x60000b, CODE_FOR_one_cmplti2 },
  { 0x60000c, CODE_FOR_one_cmplpti2 },
  { 0x600033, CODE_FOR_one_cmplv16qi2 },
  { 0x600034, CODE_FOR_one_cmplv8hi2 },
  { 0x600035, CODE_FOR_one_cmplv4si2 },
  { 0x600036, CODE_FOR_one_cmplv2di2 },
  { 0x600037, CODE_FOR_one_cmplv1ti2 },
  { 0x60003e, CODE_FOR_one_cmplv4sf2 },
  { 0x60003f, CODE_FOR_one_cmplv2df2 },
  { 0x610008, CODE_FOR_bswaphi2 },
  { 0x610009, CODE_FOR_bswapsi2 },
  { 0x61000a, CODE_FOR_bswapdi2 },
  { 0x620009, CODE_FOR_ffssi2 },
  { 0x62000a, CODE_FOR_ffsdi2 },
  { 0x630009, CODE_FOR_clzsi2 },
  { 0x63000a, CODE_FOR_clzdi2 },
  { 0x630033, CODE_FOR_clzv16qi2 },
  { 0x630034, CODE_FOR_clzv8hi2 },
  { 0x630035, CODE_FOR_clzv4si2 },
  { 0x630036, CODE_FOR_clzv2di2 },
  { 0x640009, CODE_FOR_ctzsi2 },
  { 0x64000a, CODE_FOR_ctzdi2 },
  { 0x640033, CODE_FOR_ctzv16qi2 },
  { 0x640034, CODE_FOR_ctzv8hi2 },
  { 0x640035, CODE_FOR_ctzv4si2 },
  { 0x640036, CODE_FOR_ctzv2di2 },
  { 0x660009, CODE_FOR_popcountsi2 },
  { 0x66000a, CODE_FOR_popcountdi2 },
  { 0x660033, CODE_FOR_popcountv16qi2 },
  { 0x660034, CODE_FOR_popcountv8hi2 },
  { 0x660035, CODE_FOR_popcountv4si2 },
  { 0x660036, CODE_FOR_popcountv2di2 },
  { 0x670009, CODE_FOR_paritysi2 },
  { 0x67000a, CODE_FOR_paritydi2 },
  { 0x67000b, CODE_FOR_parityti2 },
  { 0x670034, CODE_FOR_parityv8hi2 },
  { 0x670035, CODE_FOR_parityv4si2 },
  { 0x670036, CODE_FOR_parityv2di2 },
  { 0x670037, CODE_FOR_parityv1ti2 },
  { 0x72001f, CODE_FOR_sqrtsf2 },
  { 0x720020, CODE_FOR_sqrtdf2 },
  { 0x720021, CODE_FOR_sqrtkf2 },
  { 0x720022, CODE_FOR_sqrttf2 },
  { 0x72003e, CODE_FOR_sqrtv4sf2 },
  { 0x72003f, CODE_FOR_sqrtv2df2 },
  { 0x810002, CODE_FOR_movcc },
  { 0x810007, CODE_FOR_movqi },
  { 0x810008, CODE_FOR_movhi },
  { 0x810009, CODE_FOR_movsi },
  { 0x81000a, CODE_FOR_movdi },
  { 0x81000b, CODE_FOR_movti },
  { 0x81000c, CODE_FOR_movpti },
  { 0x81001f, CODE_FOR_movsf },
  { 0x810020, CODE_FOR_movdf },
  { 0x810021, CODE_FOR_movkf },
  { 0x810022, CODE_FOR_movtf },
  { 0x810023, CODE_FOR_movif },
  { 0x810024, CODE_FOR_movsd },
  { 0x810025, CODE_FOR_movdd },
  { 0x810026, CODE_FOR_movtd },
  { 0x810033, CODE_FOR_movv16qi },
  { 0x810034, CODE_FOR_movv8hi },
  { 0x810035, CODE_FOR_movv4si },
  { 0x810036, CODE_FOR_movv2di },
  { 0x810037, CODE_FOR_movv1ti },
  { 0x81003e, CODE_FOR_movv4sf },
  { 0x81003f, CODE_FOR_movv2df },
  { 0x810045, CODE_FOR_movoo },
  { 0x810046, CODE_FOR_movxo },
  { 0x830021, CODE_FOR_movmisalignkf },
  { 0x830022, CODE_FOR_movmisaligntf },
  { 0x830035, CODE_FOR_movmisalignv4si },
  { 0x830036, CODE_FOR_movmisalignv2di },
  { 0x830037, CODE_FOR_movmisalignv1ti },
  { 0x83003e, CODE_FOR_movmisalignv4sf },
  { 0x83003f, CODE_FOR_movmisalignv2df },
  { 0x8e0009, CODE_FOR_cbranchsi4 },
  { 0x8e000a, CODE_FOR_cbranchdi4 },
  { 0x8e001f, CODE_FOR_cbranchsf4 },
  { 0x8e0020, CODE_FOR_cbranchdf4 },
  { 0x8e0021, CODE_FOR_cbranchkf4 },
  { 0x8e0022, CODE_FOR_cbranchtf4 },
  { 0x8e0023, CODE_FOR_cbranchif4 },
  { 0x8e0025, CODE_FOR_cbranchdd4 },
  { 0x8e0026, CODE_FOR_cbranchtd4 },
  { 0x920009, CODE_FOR_movsicc },
  { 0x92000a, CODE_FOR_movdicc },
  { 0x92001f, CODE_FOR_movsfcc },
  { 0x920020, CODE_FOR_movdfcc },
  { 0x920021, CODE_FOR_movkfcc },
  { 0x920022, CODE_FOR_movtfcc },
  { 0xac0009, CODE_FOR_cstoresi4 },
  { 0xac000a, CODE_FOR_cstoredi4 },
  { 0xac001f, CODE_FOR_cstoresf4 },
  { 0xac0020, CODE_FOR_cstoredf4 },
  { 0xac0021, CODE_FOR_cstorekf4 },
  { 0xac0022, CODE_FOR_cstoretf4 },
  { 0xac0023, CODE_FOR_cstoreif4 },
  { 0xac0025, CODE_FOR_cstoredd4 },
  { 0xac0026, CODE_FOR_cstoretd4 },
  { 0xad0009, CODE_FOR_ctrapsi4 },
  { 0xad000a, CODE_FOR_ctrapdi4 },
  { 0xb70009, CODE_FOR_smulsi3_highpart },
  { 0xb7000a, CODE_FOR_smuldi3_highpart },
  { 0xb70035, CODE_FOR_smulv4si3_highpart },
  { 0xb70036, CODE_FOR_smulv2di3_highpart },
  { 0xb80009, CODE_FOR_umulsi3_highpart },
  { 0xb8000a, CODE_FOR_umuldi3_highpart },
  { 0xb80035, CODE_FOR_umulv4si3_highpart },
  { 0xb80036, CODE_FOR_umulv2di3_highpart },
  { 0xb90009, CODE_FOR_cmpmemsi },
  { 0xba0009, CODE_FOR_cmpstrsi },
  { 0xbb0009, CODE_FOR_cmpstrnsi },
  { 0xbc0009, CODE_FOR_cpymemsi },
  { 0xbd0009, CODE_FOR_movmemsi },
  { 0xbe0009, CODE_FOR_setmemsi },
  { 0xbf0009, CODE_FOR_strlensi },
  { 0xc1001f, CODE_FOR_fmasf4 },
  { 0xc10020, CODE_FOR_fmadf4 },
  { 0xc10021, CODE_FOR_fmakf4 },
  { 0xc10022, CODE_FOR_fmatf4 },
  { 0xc10034, CODE_FOR_fmav8hi4 },
  { 0xc1003e, CODE_FOR_fmav4sf4 },
  { 0xc1003f, CODE_FOR_fmav2df4 },
  { 0xc2001f, CODE_FOR_fmssf4 },
  { 0xc20020, CODE_FOR_fmsdf4 },
  { 0xc20021, CODE_FOR_fmskf4 },
  { 0xc20022, CODE_FOR_fmstf4 },
  { 0xc2003e, CODE_FOR_fmsv4sf4 },
  { 0xc2003f, CODE_FOR_fmsv2df4 },
  { 0xc3001f, CODE_FOR_fnmasf4 },
  { 0xc30020, CODE_FOR_fnmadf4 },
  { 0xc30021, CODE_FOR_fnmakf4 },
  { 0xc30022, CODE_FOR_fnmatf4 },
  { 0xc3003e, CODE_FOR_fnmav4sf4 },
  { 0xc3003f, CODE_FOR_fnmav2df4 },
  { 0xc4001f, CODE_FOR_fnmssf4 },
  { 0xc40020, CODE_FOR_fnmsdf4 },
  { 0xc40021, CODE_FOR_fnmskf4 },
  { 0xc40022, CODE_FOR_fnmstf4 },
  { 0xc4003e, CODE_FOR_fnmsv4sf4 },
  { 0xc4003f, CODE_FOR_fnmsv2df4 },
  { 0xc6001f, CODE_FOR_roundsf2 },
  { 0xc60020, CODE_FOR_rounddf2 },
  { 0xc60021, CODE_FOR_roundkf2 },
  { 0xc60022, CODE_FOR_roundtf2 },
  { 0xc8001f, CODE_FOR_floorsf2 },
  { 0xc80020, CODE_FOR_floordf2 },
  { 0xc80021, CODE_FOR_floorkf2 },
  { 0xc80022, CODE_FOR_floortf2 },
  { 0xc9001f, CODE_FOR_ceilsf2 },
  { 0xc90020, CODE_FOR_ceildf2 },
  { 0xc90021, CODE_FOR_ceilkf2 },
  { 0xc90022, CODE_FOR_ceiltf2 },
  { 0xca001f, CODE_FOR_btruncsf2 },
  { 0xca0020, CODE_FOR_btruncdf2 },
  { 0xca0021, CODE_FOR_btrunckf2 },
  { 0xca0022, CODE_FOR_btrunctf2 },
  { 0xd3001f, CODE_FOR_copysignsf3 },
  { 0xd30020, CODE_FOR_copysigndf3 },
  { 0xd30021, CODE_FOR_copysignkf3 },
  { 0xd30022, CODE_FOR_copysigntf3 },
  { 0xe3001f, CODE_FOR_fmodsf3 },
  { 0xe30020, CODE_FOR_fmoddf3 },
  { 0xee001f, CODE_FOR_remaindersf3 },
  { 0xee0020, CODE_FOR_remainderdf3 },
  { 0xef001f, CODE_FOR_rsqrtsf2 },
  { 0xef0020, CODE_FOR_rsqrtdf2 },
  { 0xef003e, CODE_FOR_rsqrtv4sf2 },
  { 0xef003f, CODE_FOR_rsqrtv2df2 },
  { 0xf10021, CODE_FOR_signbitkf2 },
  { 0xf10022, CODE_FOR_signbittf2 },
  { 0xf10023, CODE_FOR_signbitif2 },
  { 0xf80009, CODE_FOR_fegetroundsi },
  { 0xf90009, CODE_FOR_feclearexceptsi },
  { 0xfa0009, CODE_FOR_feraiseexceptsi },
  { 0xff003e, CODE_FOR_reduc_smax_scal_v4sf },
  { 0xff003f, CODE_FOR_reduc_smax_scal_v2df },
  { 0x100003e, CODE_FOR_reduc_smin_scal_v4sf },
  { 0x100003f, CODE_FOR_reduc_smin_scal_v2df },
  { 0x1010033, CODE_FOR_reduc_plus_scal_v16qi },
  { 0x1010034, CODE_FOR_reduc_plus_scal_v8hi },
  { 0x101003e, CODE_FOR_reduc_plus_scal_v4sf },
  { 0x101003f, CODE_FOR_reduc_plus_scal_v2df },
  { 0x10d0033, CODE_FOR_avgv16qi3_ceil },
  { 0x10d0034, CODE_FOR_avgv8hi3_ceil },
  { 0x10d0035, CODE_FOR_avgv4si3_ceil },
  { 0x10e0033, CODE_FOR_uavgv16qi3_ceil },
  { 0x10e0034, CODE_FOR_uavgv8hi3_ceil },
  { 0x10e0035, CODE_FOR_uavgv4si3_ceil },
  { 0x10f0034, CODE_FOR_sdot_prodv8hi },
  { 0x1100033, CODE_FOR_widen_ssumv16qi3 },
  { 0x1100034, CODE_FOR_widen_ssumv8hi3 },
  { 0x1110033, CODE_FOR_udot_prodv16qi },
  { 0x1110034, CODE_FOR_udot_prodv8hi },
  { 0x1130033, CODE_FOR_widen_usumv16qi3 },
  { 0x1130034, CODE_FOR_widen_usumv8hi3 },
  { 0x1140033, CODE_FOR_usadv16qi },
  { 0x1140034, CODE_FOR_usadv8hi },
  { 0x11b003f, CODE_FOR_vec_pack_sfix_trunc_v2df },
  { 0x11d0034, CODE_FOR_vec_pack_trunc_v8hi },
  { 0x11d0035, CODE_FOR_vec_pack_trunc_v4si },
  { 0x11d0036, CODE_FOR_vec_pack_trunc_v2di },
  { 0x11d003f, CODE_FOR_vec_pack_trunc_v2df },
  { 0x11e003f, CODE_FOR_vec_pack_ufix_trunc_v2df },
  { 0x1210036, CODE_FOR_vec_packs_float_v2di },
  { 0x1220036, CODE_FOR_vec_packu_float_v2di },
  { 0x1230033, CODE_FOR_vec_permv16qi },
  { 0x1240033, CODE_FOR_vec_realign_load_v16qi },
  { 0x1240034, CODE_FOR_vec_realign_load_v8hi },
  { 0x1240035, CODE_FOR_vec_realign_load_v4si },
  { 0x124003e, CODE_FOR_vec_realign_load_v4sf },
  { 0x1250033, CODE_FOR_vec_setv16qi },
  { 0x1250034, CODE_FOR_vec_setv8hi },
  { 0x1250035, CODE_FOR_vec_setv4si },
  { 0x1250036, CODE_FOR_vec_setv2di },
  { 0x125003e, CODE_FOR_vec_setv4sf },
  { 0x125003f, CODE_FOR_vec_setv2df },
  { 0x127000b, CODE_FOR_vec_shr_ti },
  { 0x1270021, CODE_FOR_vec_shr_kf },
  { 0x1270022, CODE_FOR_vec_shr_tf },
  { 0x1270033, CODE_FOR_vec_shr_v16qi },
  { 0x1270034, CODE_FOR_vec_shr_v8hi },
  { 0x1270035, CODE_FOR_vec_shr_v4si },
  { 0x1270036, CODE_FOR_vec_shr_v2di },
  { 0x1270037, CODE_FOR_vec_shr_v1ti },
  { 0x127003e, CODE_FOR_vec_shr_v4sf },
  { 0x127003f, CODE_FOR_vec_shr_v2df },
  { 0x128003e, CODE_FOR_vec_unpack_sfix_trunc_hi_v4sf },
  { 0x129003e, CODE_FOR_vec_unpack_sfix_trunc_lo_v4sf },
  { 0x12a003e, CODE_FOR_vec_unpack_ufix_trunc_hi_v4sf },
  { 0x12b003e, CODE_FOR_vec_unpack_ufix_trunc_lo_v4sf },
  { 0x12c0034, CODE_FOR_vec_unpacks_float_hi_v8hi },
  { 0x12c0035, CODE_FOR_vec_unpacks_float_hi_v4si },
  { 0x12d0034, CODE_FOR_vec_unpacks_float_lo_v8hi },
  { 0x12d0035, CODE_FOR_vec_unpacks_float_lo_v4si },
  { 0x12e0033, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0x12e0034, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0x12e0035, CODE_FOR_vec_unpacks_hi_v4si },
  { 0x12e003e, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0x12f0033, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0x12f0034, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0x12f0035, CODE_FOR_vec_unpacks_lo_v4si },
  { 0x12f003e, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0x1320034, CODE_FOR_vec_unpacku_float_hi_v8hi },
  { 0x1320035, CODE_FOR_vec_unpacku_float_hi_v4si },
  { 0x1330034, CODE_FOR_vec_unpacku_float_lo_v8hi },
  { 0x1330035, CODE_FOR_vec_unpacku_float_lo_v4si },
  { 0x1340033, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0x1340034, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0x1340035, CODE_FOR_vec_unpacku_hi_v4si },
  { 0x1350033, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0x1350034, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0x1350035, CODE_FOR_vec_unpacku_lo_v4si },
  { 0x1360033, CODE_FOR_vec_widen_smult_even_v16qi },
  { 0x1360034, CODE_FOR_vec_widen_smult_even_v8hi },
  { 0x1360035, CODE_FOR_vec_widen_smult_even_v4si },
  { 0x1360036, CODE_FOR_vec_widen_smult_even_v2di },
  { 0x1370033, CODE_FOR_vec_widen_smult_hi_v16qi },
  { 0x1370034, CODE_FOR_vec_widen_smult_hi_v8hi },
  { 0x1380033, CODE_FOR_vec_widen_smult_lo_v16qi },
  { 0x1380034, CODE_FOR_vec_widen_smult_lo_v8hi },
  { 0x1390033, CODE_FOR_vec_widen_smult_odd_v16qi },
  { 0x1390034, CODE_FOR_vec_widen_smult_odd_v8hi },
  { 0x1390035, CODE_FOR_vec_widen_smult_odd_v4si },
  { 0x1390036, CODE_FOR_vec_widen_smult_odd_v2di },
  { 0x1400033, CODE_FOR_vec_widen_umult_even_v16qi },
  { 0x1400034, CODE_FOR_vec_widen_umult_even_v8hi },
  { 0x1400035, CODE_FOR_vec_widen_umult_even_v4si },
  { 0x1400036, CODE_FOR_vec_widen_umult_even_v2di },
  { 0x1410033, CODE_FOR_vec_widen_umult_hi_v16qi },
  { 0x1410034, CODE_FOR_vec_widen_umult_hi_v8hi },
  { 0x1420033, CODE_FOR_vec_widen_umult_lo_v16qi },
  { 0x1420034, CODE_FOR_vec_widen_umult_lo_v8hi },
  { 0x1430033, CODE_FOR_vec_widen_umult_odd_v16qi },
  { 0x1430034, CODE_FOR_vec_widen_umult_odd_v8hi },
  { 0x1430035, CODE_FOR_vec_widen_umult_odd_v4si },
  { 0x1430036, CODE_FOR_vec_widen_umult_odd_v2di },
  { 0x1540007, CODE_FOR_atomic_add_fetchqi },
  { 0x1540008, CODE_FOR_atomic_add_fetchhi },
  { 0x1540009, CODE_FOR_atomic_add_fetchsi },
  { 0x154000a, CODE_FOR_atomic_add_fetchdi },
  { 0x154000b, CODE_FOR_atomic_add_fetchti },
  { 0x1550007, CODE_FOR_atomic_addqi },
  { 0x1550008, CODE_FOR_atomic_addhi },
  { 0x1550009, CODE_FOR_atomic_addsi },
  { 0x155000a, CODE_FOR_atomic_adddi },
  { 0x155000b, CODE_FOR_atomic_addti },
  { 0x1560007, CODE_FOR_atomic_and_fetchqi },
  { 0x1560008, CODE_FOR_atomic_and_fetchhi },
  { 0x1560009, CODE_FOR_atomic_and_fetchsi },
  { 0x156000a, CODE_FOR_atomic_and_fetchdi },
  { 0x156000b, CODE_FOR_atomic_and_fetchti },
  { 0x1570007, CODE_FOR_atomic_andqi },
  { 0x1570008, CODE_FOR_atomic_andhi },
  { 0x1570009, CODE_FOR_atomic_andsi },
  { 0x157000a, CODE_FOR_atomic_anddi },
  { 0x157000b, CODE_FOR_atomic_andti },
  { 0x15b0007, CODE_FOR_atomic_compare_and_swapqi },
  { 0x15b0008, CODE_FOR_atomic_compare_and_swaphi },
  { 0x15b0009, CODE_FOR_atomic_compare_and_swapsi },
  { 0x15b000a, CODE_FOR_atomic_compare_and_swapdi },
  { 0x15b000b, CODE_FOR_atomic_compare_and_swapti },
  { 0x15c0007, CODE_FOR_atomic_exchangeqi },
  { 0x15c0008, CODE_FOR_atomic_exchangehi },
  { 0x15c0009, CODE_FOR_atomic_exchangesi },
  { 0x15c000a, CODE_FOR_atomic_exchangedi },
  { 0x15c000b, CODE_FOR_atomic_exchangeti },
  { 0x15d0007, CODE_FOR_atomic_fetch_addqi },
  { 0x15d0008, CODE_FOR_atomic_fetch_addhi },
  { 0x15d0009, CODE_FOR_atomic_fetch_addsi },
  { 0x15d000a, CODE_FOR_atomic_fetch_adddi },
  { 0x15d000b, CODE_FOR_atomic_fetch_addti },
  { 0x15e0007, CODE_FOR_atomic_fetch_andqi },
  { 0x15e0008, CODE_FOR_atomic_fetch_andhi },
  { 0x15e0009, CODE_FOR_atomic_fetch_andsi },
  { 0x15e000a, CODE_FOR_atomic_fetch_anddi },
  { 0x15e000b, CODE_FOR_atomic_fetch_andti },
  { 0x15f0007, CODE_FOR_atomic_fetch_nandqi },
  { 0x15f0008, CODE_FOR_atomic_fetch_nandhi },
  { 0x15f0009, CODE_FOR_atomic_fetch_nandsi },
  { 0x15f000a, CODE_FOR_atomic_fetch_nanddi },
  { 0x15f000b, CODE_FOR_atomic_fetch_nandti },
  { 0x1600007, CODE_FOR_atomic_fetch_orqi },
  { 0x1600008, CODE_FOR_atomic_fetch_orhi },
  { 0x1600009, CODE_FOR_atomic_fetch_orsi },
  { 0x160000a, CODE_FOR_atomic_fetch_ordi },
  { 0x160000b, CODE_FOR_atomic_fetch_orti },
  { 0x1610007, CODE_FOR_atomic_fetch_subqi },
  { 0x1610008, CODE_FOR_atomic_fetch_subhi },
  { 0x1610009, CODE_FOR_atomic_fetch_subsi },
  { 0x161000a, CODE_FOR_atomic_fetch_subdi },
  { 0x161000b, CODE_FOR_atomic_fetch_subti },
  { 0x1620007, CODE_FOR_atomic_fetch_xorqi },
  { 0x1620008, CODE_FOR_atomic_fetch_xorhi },
  { 0x1620009, CODE_FOR_atomic_fetch_xorsi },
  { 0x162000a, CODE_FOR_atomic_fetch_xordi },
  { 0x162000b, CODE_FOR_atomic_fetch_xorti },
  { 0x1630007, CODE_FOR_atomic_loadqi },
  { 0x1630008, CODE_FOR_atomic_loadhi },
  { 0x1630009, CODE_FOR_atomic_loadsi },
  { 0x163000a, CODE_FOR_atomic_loaddi },
  { 0x163000b, CODE_FOR_atomic_loadti },
  { 0x1640007, CODE_FOR_atomic_nand_fetchqi },
  { 0x1640008, CODE_FOR_atomic_nand_fetchhi },
  { 0x1640009, CODE_FOR_atomic_nand_fetchsi },
  { 0x164000a, CODE_FOR_atomic_nand_fetchdi },
  { 0x164000b, CODE_FOR_atomic_nand_fetchti },
  { 0x1650007, CODE_FOR_atomic_nandqi },
  { 0x1650008, CODE_FOR_atomic_nandhi },
  { 0x1650009, CODE_FOR_atomic_nandsi },
  { 0x165000a, CODE_FOR_atomic_nanddi },
  { 0x165000b, CODE_FOR_atomic_nandti },
  { 0x1660007, CODE_FOR_atomic_or_fetchqi },
  { 0x1660008, CODE_FOR_atomic_or_fetchhi },
  { 0x1660009, CODE_FOR_atomic_or_fetchsi },
  { 0x166000a, CODE_FOR_atomic_or_fetchdi },
  { 0x166000b, CODE_FOR_atomic_or_fetchti },
  { 0x1670007, CODE_FOR_atomic_orqi },
  { 0x1670008, CODE_FOR_atomic_orhi },
  { 0x1670009, CODE_FOR_atomic_orsi },
  { 0x167000a, CODE_FOR_atomic_ordi },
  { 0x167000b, CODE_FOR_atomic_orti },
  { 0x1680007, CODE_FOR_atomic_storeqi },
  { 0x1680008, CODE_FOR_atomic_storehi },
  { 0x1680009, CODE_FOR_atomic_storesi },
  { 0x168000a, CODE_FOR_atomic_storedi },
  { 0x168000b, CODE_FOR_atomic_storeti },
  { 0x1690007, CODE_FOR_atomic_sub_fetchqi },
  { 0x1690008, CODE_FOR_atomic_sub_fetchhi },
  { 0x1690009, CODE_FOR_atomic_sub_fetchsi },
  { 0x169000a, CODE_FOR_atomic_sub_fetchdi },
  { 0x169000b, CODE_FOR_atomic_sub_fetchti },
  { 0x16a0007, CODE_FOR_atomic_subqi },
  { 0x16a0008, CODE_FOR_atomic_subhi },
  { 0x16a0009, CODE_FOR_atomic_subsi },
  { 0x16a000a, CODE_FOR_atomic_subdi },
  { 0x16a000b, CODE_FOR_atomic_subti },
  { 0x16b0007, CODE_FOR_atomic_xor_fetchqi },
  { 0x16b0008, CODE_FOR_atomic_xor_fetchhi },
  { 0x16b0009, CODE_FOR_atomic_xor_fetchsi },
  { 0x16b000a, CODE_FOR_atomic_xor_fetchdi },
  { 0x16b000b, CODE_FOR_atomic_xor_fetchti },
  { 0x16c0007, CODE_FOR_atomic_xorqi },
  { 0x16c0008, CODE_FOR_atomic_xorhi },
  { 0x16c0009, CODE_FOR_atomic_xorsi },
  { 0x16c000a, CODE_FOR_atomic_xordi },
  { 0x16c000b, CODE_FOR_atomic_xorti },
  { 0x1790033, CODE_FOR_len_load_v16qi },
  { 0x17a0033, CODE_FOR_len_store_v16qi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqisi2;
  ena[1] = HAVE_extendqidi2;
  ena[2] = HAVE_extendhisi2;
  ena[3] = HAVE_extendhidi2;
  ena[4] = HAVE_extendsidi2;
  ena[5] = HAVE_extendditi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_extendsfkf2;
  ena[8] = HAVE_extendsftf2;
  ena[9] = HAVE_extendsfif2;
  ena[10] = HAVE_extenddfkf2;
  ena[11] = HAVE_extenddftf2;
  ena[12] = HAVE_extenddfif2;
  ena[13] = HAVE_extendkftf2;
  ena[14] = HAVE_extendtfkf2;
  ena[15] = HAVE_extendtfif2;
  ena[16] = HAVE_extendifkf2;
  ena[17] = HAVE_extendiftf2;
  ena[18] = HAVE_extendsddd2;
  ena[19] = HAVE_extendsdtd2;
  ena[20] = HAVE_extendddtd2;
  ena[21] = HAVE_truncdfsf2;
  ena[22] = HAVE_trunckfsf2;
  ena[23] = HAVE_trunckfdf2;
  ena[24] = HAVE_trunckftf2;
  ena[25] = HAVE_trunctfsf2;
  ena[26] = HAVE_trunctfdf2;
  ena[27] = HAVE_trunctfkf2;
  ena[28] = HAVE_trunctfif2;
  ena[29] = HAVE_truncifsf2;
  ena[30] = HAVE_truncifdf2;
  ena[31] = HAVE_truncifkf2;
  ena[32] = HAVE_trunciftf2;
  ena[33] = HAVE_truncddsd2;
  ena[34] = HAVE_trunctdsd2;
  ena[35] = HAVE_trunctddd2;
  ena[36] = HAVE_zero_extendqisi2;
  ena[37] = HAVE_zero_extendqidi2;
  ena[38] = HAVE_zero_extendhisi2;
  ena[39] = HAVE_zero_extendhidi2;
  ena[40] = HAVE_zero_extendsidi2;
  ena[41] = HAVE_fixdddi2;
  ena[42] = HAVE_fixtddi2;
  ena[43] = HAVE_fixtdti2;
  ena[44] = HAVE_floatqisf2;
  ena[45] = HAVE_floatqidf2;
  ena[46] = HAVE_floatqikf2;
  ena[47] = HAVE_floatqitf2;
  ena[48] = HAVE_floathisf2;
  ena[49] = HAVE_floathidf2;
  ena[50] = HAVE_floathikf2;
  ena[51] = HAVE_floathitf2;
  ena[52] = HAVE_floatsisf2;
  ena[53] = HAVE_floatsidf2;
  ena[54] = HAVE_floatsikf2;
  ena[55] = HAVE_floatsitf2;
  ena[56] = HAVE_floatsiif2;
  ena[57] = HAVE_floatdisf2;
  ena[58] = HAVE_floatdidf2;
  ena[59] = HAVE_floatdikf2;
  ena[60] = HAVE_floatditf2;
  ena[61] = HAVE_floatdidd2;
  ena[62] = HAVE_floatditd2;
  ena[63] = HAVE_floattikf2;
  ena[64] = HAVE_floattitf2;
  ena[65] = HAVE_floattitd2;
  ena[66] = HAVE_floatv4siv4sf2;
  ena[67] = HAVE_floatv2div2df2;
  ena[68] = HAVE_floatunsqisf2;
  ena[69] = HAVE_floatunsqidf2;
  ena[70] = HAVE_floatunsqikf2;
  ena[71] = HAVE_floatunsqitf2;
  ena[72] = HAVE_floatunshisf2;
  ena[73] = HAVE_floatunshidf2;
  ena[74] = HAVE_floatunshikf2;
  ena[75] = HAVE_floatunshitf2;
  ena[76] = HAVE_floatunssisf2;
  ena[77] = HAVE_floatunssidf2;
  ena[78] = HAVE_floatunsdisf2;
  ena[79] = HAVE_floatunsdidf2;
  ena[80] = HAVE_floatunsdikf2;
  ena[81] = HAVE_floatunsditf2;
  ena[82] = HAVE_floatunstikf2;
  ena[83] = HAVE_floatunstitf2;
  ena[84] = HAVE_floatunsv4siv4sf2;
  ena[85] = HAVE_floatunsv2div2df2;
  ena[86] = HAVE_lrintsfdi2;
  ena[87] = HAVE_lrintdfdi2;
  ena[88] = HAVE_lroundsfdi2;
  ena[89] = HAVE_lrounddfdi2;
  ena[90] = HAVE_fix_truncsfqi2;
  ena[91] = HAVE_fix_truncsfhi2;
  ena[92] = HAVE_fix_truncsfsi2;
  ena[93] = HAVE_fix_truncsfdi2;
  ena[94] = HAVE_fix_truncdfqi2;
  ena[95] = HAVE_fix_truncdfhi2;
  ena[96] = HAVE_fix_truncdfsi2;
  ena[97] = HAVE_fix_truncdfdi2;
  ena[98] = HAVE_fix_trunckfqi2;
  ena[99] = HAVE_fix_trunckfhi2;
  ena[100] = HAVE_fix_trunckfsi2;
  ena[101] = HAVE_fix_trunckfdi2;
  ena[102] = HAVE_fix_trunckfti2;
  ena[103] = HAVE_fix_trunctfqi2;
  ena[104] = HAVE_fix_trunctfhi2;
  ena[105] = HAVE_fix_trunctfsi2;
  ena[106] = HAVE_fix_trunctfdi2;
  ena[107] = HAVE_fix_trunctfti2;
  ena[108] = HAVE_fix_truncifsi2;
  ena[109] = HAVE_fix_truncv4sfv4si2;
  ena[110] = HAVE_fix_truncv2dfv2di2;
  ena[111] = HAVE_fixuns_truncsfqi2;
  ena[112] = HAVE_fixuns_truncsfhi2;
  ena[113] = HAVE_fixuns_truncsfsi2;
  ena[114] = HAVE_fixuns_truncsfdi2;
  ena[115] = HAVE_fixuns_truncdfqi2;
  ena[116] = HAVE_fixuns_truncdfhi2;
  ena[117] = HAVE_fixuns_truncdfsi2;
  ena[118] = HAVE_fixuns_truncdfdi2;
  ena[119] = HAVE_fixuns_trunckfqi2;
  ena[120] = HAVE_fixuns_trunckfhi2;
  ena[121] = HAVE_fixuns_trunckfsi2;
  ena[122] = HAVE_fixuns_trunckfdi2;
  ena[123] = HAVE_fixuns_trunckfti2;
  ena[124] = HAVE_fixuns_trunctfqi2;
  ena[125] = HAVE_fixuns_trunctfhi2;
  ena[126] = HAVE_fixuns_trunctfsi2;
  ena[127] = HAVE_fixuns_trunctfdi2;
  ena[128] = HAVE_fixuns_trunctfti2;
  ena[129] = HAVE_fixuns_truncv4sfv4si2;
  ena[130] = HAVE_fixuns_truncv2dfv2di2;
  ena[131] = HAVE_mulsidi3;
  ena[132] = HAVE_mulditi3;
  ena[133] = HAVE_umulsidi3;
  ena[134] = HAVE_umulditi3;
  ena[135] = HAVE_vcondv16qiv16qi;
  ena[136] = HAVE_vcondv8hiv8hi;
  ena[137] = HAVE_vcondv4siv4si;
  ena[138] = HAVE_vcondv4sfv4si;
  ena[139] = HAVE_vcondv2div2di;
  ena[140] = HAVE_vcondv2dfv2di;
  ena[141] = HAVE_vcondv4siv4sf;
  ena[142] = HAVE_vcondv4sfv4sf;
  ena[143] = HAVE_vcondv2div2df;
  ena[144] = HAVE_vcondv2dfv2df;
  ena[145] = HAVE_vconduv16qiv16qi;
  ena[146] = HAVE_vconduv8hiv8hi;
  ena[147] = HAVE_vconduv4siv4si;
  ena[148] = HAVE_vconduv4sfv4si;
  ena[149] = HAVE_vconduv2div2di;
  ena[150] = HAVE_vconduv2dfv2di;
  ena[151] = HAVE_vcond_mask_v16qiv16qi;
  ena[152] = HAVE_vcond_mask_v8hiv8hi;
  ena[153] = HAVE_vcond_mask_v4siv4si;
  ena[154] = HAVE_vcond_mask_v4sfv4si;
  ena[155] = HAVE_vcond_mask_v2div2di;
  ena[156] = HAVE_vcond_mask_v2dfv2di;
  ena[157] = HAVE_vec_cmpv16qiv16qi;
  ena[158] = HAVE_vec_cmpv8hiv8hi;
  ena[159] = HAVE_vec_cmpv4siv4si;
  ena[160] = HAVE_vec_cmpv4sfv4si;
  ena[161] = HAVE_vec_cmpv2div2di;
  ena[162] = HAVE_vec_cmpv2dfv2di;
  ena[163] = HAVE_vec_cmpuv16qiv16qi;
  ena[164] = HAVE_vec_cmpuv8hiv8hi;
  ena[165] = HAVE_vec_cmpuv4siv4si;
  ena[166] = HAVE_vec_cmpuv2div2di;
  ena[167] = HAVE_vec_extractv16qiqi;
  ena[168] = HAVE_vec_extractv8hihi;
  ena[169] = HAVE_vec_extractv4sisi;
  ena[170] = HAVE_vec_extractv2didi;
  ena[171] = HAVE_vec_extractv4sfsf;
  ena[172] = HAVE_vec_extractv2dfdf;
  ena[173] = HAVE_vec_initv16qiqi;
  ena[174] = HAVE_vec_initv8hihi;
  ena[175] = HAVE_vec_initv4sisi;
  ena[176] = HAVE_vec_initv2didi;
  ena[177] = HAVE_vec_initv4sfsf;
  ena[178] = HAVE_vec_initv2dfdf;
  ena[179] = HAVE_addsi3;
  ena[180] = HAVE_adddi3;
  ena[181] = HAVE_addti3;
  ena[182] = HAVE_addsf3;
  ena[183] = HAVE_adddf3;
  ena[184] = HAVE_addkf3;
  ena[185] = HAVE_addtf3;
  ena[186] = HAVE_adddd3;
  ena[187] = HAVE_addtd3;
  ena[188] = HAVE_addv16qi3;
  ena[189] = HAVE_addv8hi3;
  ena[190] = HAVE_addv4si3;
  ena[191] = HAVE_addv2di3;
  ena[192] = HAVE_addv4sf3;
  ena[193] = HAVE_addv2df3;
  ena[194] = HAVE_subsi3;
  ena[195] = HAVE_subdi3;
  ena[196] = HAVE_subti3;
  ena[197] = HAVE_subsf3;
  ena[198] = HAVE_subdf3;
  ena[199] = HAVE_subkf3;
  ena[200] = HAVE_subtf3;
  ena[201] = HAVE_subdd3;
  ena[202] = HAVE_subtd3;
  ena[203] = HAVE_subv16qi3;
  ena[204] = HAVE_subv8hi3;
  ena[205] = HAVE_subv4si3;
  ena[206] = HAVE_subv2di3;
  ena[207] = HAVE_subv4sf3;
  ena[208] = HAVE_subv2df3;
  ena[209] = HAVE_mulsi3;
  ena[210] = HAVE_muldi3;
  ena[211] = HAVE_mulsf3;
  ena[212] = HAVE_muldf3;
  ena[213] = HAVE_mulkf3;
  ena[214] = HAVE_multf3;
  ena[215] = HAVE_muldd3;
  ena[216] = HAVE_multd3;
  ena[217] = HAVE_mulv16qi3;
  ena[218] = HAVE_mulv8hi3;
  ena[219] = HAVE_mulv4si3;
  ena[220] = HAVE_mulv2di3;
  ena[221] = HAVE_mulv4sf3;
  ena[222] = HAVE_mulv2df3;
  ena[223] = HAVE_divsi3;
  ena[224] = HAVE_divdi3;
  ena[225] = HAVE_divti3;
  ena[226] = HAVE_divsf3;
  ena[227] = HAVE_divdf3;
  ena[228] = HAVE_divkf3;
  ena[229] = HAVE_divtf3;
  ena[230] = HAVE_divdd3;
  ena[231] = HAVE_divtd3;
  ena[232] = HAVE_divv4si3;
  ena[233] = HAVE_divv2di3;
  ena[234] = HAVE_divv4sf3;
  ena[235] = HAVE_divv2df3;
  ena[236] = HAVE_udivsi3;
  ena[237] = HAVE_udivdi3;
  ena[238] = HAVE_udivti3;
  ena[239] = HAVE_udivv4si3;
  ena[240] = HAVE_udivv2di3;
  ena[241] = HAVE_modsi3;
  ena[242] = HAVE_moddi3;
  ena[243] = HAVE_modti3;
  ena[244] = HAVE_modv4si3;
  ena[245] = HAVE_modv2di3;
  ena[246] = HAVE_umodsi3;
  ena[247] = HAVE_umoddi3;
  ena[248] = HAVE_umodti3;
  ena[249] = HAVE_umodv4si3;
  ena[250] = HAVE_umodv2di3;
  ena[251] = HAVE_ftruncdd2;
  ena[252] = HAVE_ftrunctd2;
  ena[253] = HAVE_ftruncv4sf2;
  ena[254] = HAVE_ftruncv2df2;
  ena[255] = HAVE_andsi3;
  ena[256] = HAVE_anddi3;
  ena[257] = HAVE_andti3;
  ena[258] = HAVE_andpti3;
  ena[259] = HAVE_andcpti3;
  ena[260] = HAVE_andcti3;
  ena[261] = HAVE_andv16qi3;
  ena[262] = HAVE_andv8hi3;
  ena[263] = HAVE_andv4si3;
  ena[264] = HAVE_andv2di3;
  ena[265] = HAVE_andv1ti3;
  ena[266] = HAVE_andv4sf3;
  ena[267] = HAVE_andv2df3;
  ena[268] = HAVE_iorsi3;
  ena[269] = HAVE_iordi3;
  ena[270] = HAVE_iorti3;
  ena[271] = HAVE_iorpti3;
  ena[272] = HAVE_iorv16qi3;
  ena[273] = HAVE_iorv8hi3;
  ena[274] = HAVE_iorv4si3;
  ena[275] = HAVE_iorv2di3;
  ena[276] = HAVE_iorv1ti3;
  ena[277] = HAVE_iorv4sf3;
  ena[278] = HAVE_iorv2df3;
  ena[279] = HAVE_xorsi3;
  ena[280] = HAVE_xordi3;
  ena[281] = HAVE_xorti3;
  ena[282] = HAVE_xorpti3;
  ena[283] = HAVE_xorv16qi3;
  ena[284] = HAVE_xorv8hi3;
  ena[285] = HAVE_xorv4si3;
  ena[286] = HAVE_xorv2di3;
  ena[287] = HAVE_xorv1ti3;
  ena[288] = HAVE_xorv4sf3;
  ena[289] = HAVE_xorv2df3;
  ena[290] = HAVE_ashlsi3;
  ena[291] = HAVE_ashldi3;
  ena[292] = HAVE_ashrsi3;
  ena[293] = HAVE_ashrdi3;
  ena[294] = HAVE_lshrsi3;
  ena[295] = HAVE_lshrdi3;
  ena[296] = HAVE_rotlsi3;
  ena[297] = HAVE_rotldi3;
  ena[298] = HAVE_vashlti3;
  ena[299] = HAVE_vashlv16qi3;
  ena[300] = HAVE_vashlv8hi3;
  ena[301] = HAVE_vashlv4si3;
  ena[302] = HAVE_vashlv2di3;
  ena[303] = HAVE_vashlv1ti3;
  ena[304] = HAVE_vashrv16qi3;
  ena[305] = HAVE_vashrv8hi3;
  ena[306] = HAVE_vashrv4si3;
  ena[307] = HAVE_vashrv2di3;
  ena[308] = HAVE_vashrv1ti3;
  ena[309] = HAVE_vlshrti3;
  ena[310] = HAVE_vlshrv16qi3;
  ena[311] = HAVE_vlshrv8hi3;
  ena[312] = HAVE_vlshrv4si3;
  ena[313] = HAVE_vlshrv2di3;
  ena[314] = HAVE_vlshrv1ti3;
  ena[315] = HAVE_vrotlv16qi3;
  ena[316] = HAVE_vrotlv8hi3;
  ena[317] = HAVE_vrotlv4si3;
  ena[318] = HAVE_vrotlv2di3;
  ena[319] = HAVE_vrotlv1ti3;
  ena[320] = HAVE_vrotrv16qi3;
  ena[321] = HAVE_vrotrv8hi3;
  ena[322] = HAVE_vrotrv4si3;
  ena[323] = HAVE_vrotrv2di3;
  ena[324] = HAVE_sminsf3;
  ena[325] = HAVE_smindf3;
  ena[326] = HAVE_sminkf3;
  ena[327] = HAVE_smintf3;
  ena[328] = HAVE_sminv16qi3;
  ena[329] = HAVE_sminv8hi3;
  ena[330] = HAVE_sminv4si3;
  ena[331] = HAVE_sminv2di3;
  ena[332] = HAVE_sminv4sf3;
  ena[333] = HAVE_sminv2df3;
  ena[334] = HAVE_smaxsf3;
  ena[335] = HAVE_smaxdf3;
  ena[336] = HAVE_smaxkf3;
  ena[337] = HAVE_smaxtf3;
  ena[338] = HAVE_smaxv16qi3;
  ena[339] = HAVE_smaxv8hi3;
  ena[340] = HAVE_smaxv4si3;
  ena[341] = HAVE_smaxv2di3;
  ena[342] = HAVE_smaxv4sf3;
  ena[343] = HAVE_smaxv2df3;
  ena[344] = HAVE_uminv16qi3;
  ena[345] = HAVE_uminv8hi3;
  ena[346] = HAVE_uminv4si3;
  ena[347] = HAVE_uminv2di3;
  ena[348] = HAVE_umaxv16qi3;
  ena[349] = HAVE_umaxv8hi3;
  ena[350] = HAVE_umaxv4si3;
  ena[351] = HAVE_umaxv2di3;
  ena[352] = HAVE_negsi2;
  ena[353] = HAVE_negdi2;
  ena[354] = HAVE_negsf2;
  ena[355] = HAVE_negdf2;
  ena[356] = HAVE_negkf2;
  ena[357] = HAVE_negtf2;
  ena[358] = HAVE_negif2;
  ena[359] = HAVE_negdd2;
  ena[360] = HAVE_negtd2;
  ena[361] = HAVE_negv16qi2;
  ena[362] = HAVE_negv8hi2;
  ena[363] = HAVE_negv4si2;
  ena[364] = HAVE_negv2di2;
  ena[365] = HAVE_negv4sf2;
  ena[366] = HAVE_negv2df2;
  ena[367] = HAVE_abssf2;
  ena[368] = HAVE_absdf2;
  ena[369] = HAVE_abskf2;
  ena[370] = HAVE_abstf2;
  ena[371] = HAVE_absif2;
  ena[372] = HAVE_absdd2;
  ena[373] = HAVE_abstd2;
  ena[374] = HAVE_absv16qi2;
  ena[375] = HAVE_absv8hi2;
  ena[376] = HAVE_absv4si2;
  ena[377] = HAVE_absv2di2;
  ena[378] = HAVE_absv4sf2;
  ena[379] = HAVE_absv2df2;
  ena[380] = HAVE_one_cmplsi2;
  ena[381] = HAVE_one_cmpldi2;
  ena[382] = HAVE_one_cmplti2;
  ena[383] = HAVE_one_cmplpti2;
  ena[384] = HAVE_one_cmplv16qi2;
  ena[385] = HAVE_one_cmplv8hi2;
  ena[386] = HAVE_one_cmplv4si2;
  ena[387] = HAVE_one_cmplv2di2;
  ena[388] = HAVE_one_cmplv1ti2;
  ena[389] = HAVE_one_cmplv4sf2;
  ena[390] = HAVE_one_cmplv2df2;
  ena[391] = HAVE_bswaphi2;
  ena[392] = HAVE_bswapsi2;
  ena[393] = HAVE_bswapdi2;
  ena[394] = HAVE_ffssi2;
  ena[395] = HAVE_ffsdi2;
  ena[396] = HAVE_clzsi2;
  ena[397] = HAVE_clzdi2;
  ena[398] = HAVE_clzv16qi2;
  ena[399] = HAVE_clzv8hi2;
  ena[400] = HAVE_clzv4si2;
  ena[401] = HAVE_clzv2di2;
  ena[402] = HAVE_ctzsi2;
  ena[403] = HAVE_ctzdi2;
  ena[404] = HAVE_ctzv16qi2;
  ena[405] = HAVE_ctzv8hi2;
  ena[406] = HAVE_ctzv4si2;
  ena[407] = HAVE_ctzv2di2;
  ena[408] = HAVE_popcountsi2;
  ena[409] = HAVE_popcountdi2;
  ena[410] = HAVE_popcountv16qi2;
  ena[411] = HAVE_popcountv8hi2;
  ena[412] = HAVE_popcountv4si2;
  ena[413] = HAVE_popcountv2di2;
  ena[414] = HAVE_paritysi2;
  ena[415] = HAVE_paritydi2;
  ena[416] = HAVE_parityti2;
  ena[417] = HAVE_parityv8hi2;
  ena[418] = HAVE_parityv4si2;
  ena[419] = HAVE_parityv2di2;
  ena[420] = HAVE_parityv1ti2;
  ena[421] = HAVE_sqrtsf2;
  ena[422] = HAVE_sqrtdf2;
  ena[423] = HAVE_sqrtkf2;
  ena[424] = HAVE_sqrttf2;
  ena[425] = HAVE_sqrtv4sf2;
  ena[426] = HAVE_sqrtv2df2;
  ena[427] = HAVE_movcc;
  ena[428] = HAVE_movqi;
  ena[429] = HAVE_movhi;
  ena[430] = HAVE_movsi;
  ena[431] = HAVE_movdi;
  ena[432] = HAVE_movti;
  ena[433] = HAVE_movpti;
  ena[434] = HAVE_movsf;
  ena[435] = HAVE_movdf;
  ena[436] = HAVE_movkf;
  ena[437] = HAVE_movtf;
  ena[438] = HAVE_movif;
  ena[439] = HAVE_movsd;
  ena[440] = HAVE_movdd;
  ena[441] = HAVE_movtd;
  ena[442] = HAVE_movv16qi;
  ena[443] = HAVE_movv8hi;
  ena[444] = HAVE_movv4si;
  ena[445] = HAVE_movv2di;
  ena[446] = HAVE_movv1ti;
  ena[447] = HAVE_movv4sf;
  ena[448] = HAVE_movv2df;
  ena[449] = HAVE_movoo;
  ena[450] = HAVE_movxo;
  ena[451] = HAVE_movmisalignkf;
  ena[452] = HAVE_movmisaligntf;
  ena[453] = HAVE_movmisalignv4si;
  ena[454] = HAVE_movmisalignv2di;
  ena[455] = HAVE_movmisalignv1ti;
  ena[456] = HAVE_movmisalignv4sf;
  ena[457] = HAVE_movmisalignv2df;
  ena[458] = HAVE_cbranchsi4;
  ena[459] = HAVE_cbranchdi4;
  ena[460] = HAVE_cbranchsf4;
  ena[461] = HAVE_cbranchdf4;
  ena[462] = HAVE_cbranchkf4;
  ena[463] = HAVE_cbranchtf4;
  ena[464] = HAVE_cbranchif4;
  ena[465] = HAVE_cbranchdd4;
  ena[466] = HAVE_cbranchtd4;
  ena[467] = HAVE_movsicc;
  ena[468] = HAVE_movdicc;
  ena[469] = HAVE_movsfcc;
  ena[470] = HAVE_movdfcc;
  ena[471] = HAVE_movkfcc;
  ena[472] = HAVE_movtfcc;
  ena[473] = HAVE_cstoresi4;
  ena[474] = HAVE_cstoredi4;
  ena[475] = HAVE_cstoresf4;
  ena[476] = HAVE_cstoredf4;
  ena[477] = HAVE_cstorekf4;
  ena[478] = HAVE_cstoretf4;
  ena[479] = HAVE_cstoreif4;
  ena[480] = HAVE_cstoredd4;
  ena[481] = HAVE_cstoretd4;
  ena[482] = HAVE_ctrapsi4;
  ena[483] = HAVE_ctrapdi4;
  ena[484] = HAVE_smulsi3_highpart;
  ena[485] = HAVE_smuldi3_highpart;
  ena[486] = HAVE_smulv4si3_highpart;
  ena[487] = HAVE_smulv2di3_highpart;
  ena[488] = HAVE_umulsi3_highpart;
  ena[489] = HAVE_umuldi3_highpart;
  ena[490] = HAVE_umulv4si3_highpart;
  ena[491] = HAVE_umulv2di3_highpart;
  ena[492] = HAVE_cmpmemsi;
  ena[493] = HAVE_cmpstrsi;
  ena[494] = HAVE_cmpstrnsi;
  ena[495] = HAVE_cpymemsi;
  ena[496] = HAVE_movmemsi;
  ena[497] = HAVE_setmemsi;
  ena[498] = HAVE_strlensi;
  ena[499] = HAVE_fmasf4;
  ena[500] = HAVE_fmadf4;
  ena[501] = HAVE_fmakf4;
  ena[502] = HAVE_fmatf4;
  ena[503] = HAVE_fmav8hi4;
  ena[504] = HAVE_fmav4sf4;
  ena[505] = HAVE_fmav2df4;
  ena[506] = HAVE_fmssf4;
  ena[507] = HAVE_fmsdf4;
  ena[508] = HAVE_fmskf4;
  ena[509] = HAVE_fmstf4;
  ena[510] = HAVE_fmsv4sf4;
  ena[511] = HAVE_fmsv2df4;
  ena[512] = HAVE_fnmasf4;
  ena[513] = HAVE_fnmadf4;
  ena[514] = HAVE_fnmakf4;
  ena[515] = HAVE_fnmatf4;
  ena[516] = HAVE_fnmav4sf4;
  ena[517] = HAVE_fnmav2df4;
  ena[518] = HAVE_fnmssf4;
  ena[519] = HAVE_fnmsdf4;
  ena[520] = HAVE_fnmskf4;
  ena[521] = HAVE_fnmstf4;
  ena[522] = HAVE_fnmsv4sf4;
  ena[523] = HAVE_fnmsv2df4;
  ena[524] = HAVE_roundsf2;
  ena[525] = HAVE_rounddf2;
  ena[526] = HAVE_roundkf2;
  ena[527] = HAVE_roundtf2;
  ena[528] = HAVE_floorsf2;
  ena[529] = HAVE_floordf2;
  ena[530] = HAVE_floorkf2;
  ena[531] = HAVE_floortf2;
  ena[532] = HAVE_ceilsf2;
  ena[533] = HAVE_ceildf2;
  ena[534] = HAVE_ceilkf2;
  ena[535] = HAVE_ceiltf2;
  ena[536] = HAVE_btruncsf2;
  ena[537] = HAVE_btruncdf2;
  ena[538] = HAVE_btrunckf2;
  ena[539] = HAVE_btrunctf2;
  ena[540] = HAVE_copysignsf3;
  ena[541] = HAVE_copysigndf3;
  ena[542] = HAVE_copysignkf3;
  ena[543] = HAVE_copysigntf3;
  ena[544] = HAVE_fmodsf3;
  ena[545] = HAVE_fmoddf3;
  ena[546] = HAVE_remaindersf3;
  ena[547] = HAVE_remainderdf3;
  ena[548] = HAVE_rsqrtsf2;
  ena[549] = HAVE_rsqrtdf2;
  ena[550] = HAVE_rsqrtv4sf2;
  ena[551] = HAVE_rsqrtv2df2;
  ena[552] = HAVE_signbitkf2;
  ena[553] = HAVE_signbittf2;
  ena[554] = HAVE_signbitif2;
  ena[555] = HAVE_fegetroundsi;
  ena[556] = HAVE_feclearexceptsi;
  ena[557] = HAVE_feraiseexceptsi;
  ena[558] = HAVE_reduc_smax_scal_v4sf;
  ena[559] = HAVE_reduc_smax_scal_v2df;
  ena[560] = HAVE_reduc_smin_scal_v4sf;
  ena[561] = HAVE_reduc_smin_scal_v2df;
  ena[562] = HAVE_reduc_plus_scal_v16qi;
  ena[563] = HAVE_reduc_plus_scal_v8hi;
  ena[564] = HAVE_reduc_plus_scal_v4sf;
  ena[565] = HAVE_reduc_plus_scal_v2df;
  ena[566] = HAVE_avgv16qi3_ceil;
  ena[567] = HAVE_avgv8hi3_ceil;
  ena[568] = HAVE_avgv4si3_ceil;
  ena[569] = HAVE_uavgv16qi3_ceil;
  ena[570] = HAVE_uavgv8hi3_ceil;
  ena[571] = HAVE_uavgv4si3_ceil;
  ena[572] = HAVE_sdot_prodv8hi;
  ena[573] = HAVE_widen_ssumv16qi3;
  ena[574] = HAVE_widen_ssumv8hi3;
  ena[575] = HAVE_udot_prodv16qi;
  ena[576] = HAVE_udot_prodv8hi;
  ena[577] = HAVE_widen_usumv16qi3;
  ena[578] = HAVE_widen_usumv8hi3;
  ena[579] = HAVE_usadv16qi;
  ena[580] = HAVE_usadv8hi;
  ena[581] = HAVE_vec_pack_sfix_trunc_v2df;
  ena[582] = HAVE_vec_pack_trunc_v8hi;
  ena[583] = HAVE_vec_pack_trunc_v4si;
  ena[584] = HAVE_vec_pack_trunc_v2di;
  ena[585] = HAVE_vec_pack_trunc_v2df;
  ena[586] = HAVE_vec_pack_ufix_trunc_v2df;
  ena[587] = HAVE_vec_packs_float_v2di;
  ena[588] = HAVE_vec_packu_float_v2di;
  ena[589] = HAVE_vec_permv16qi;
  ena[590] = HAVE_vec_realign_load_v16qi;
  ena[591] = HAVE_vec_realign_load_v8hi;
  ena[592] = HAVE_vec_realign_load_v4si;
  ena[593] = HAVE_vec_realign_load_v4sf;
  ena[594] = HAVE_vec_setv16qi;
  ena[595] = HAVE_vec_setv8hi;
  ena[596] = HAVE_vec_setv4si;
  ena[597] = HAVE_vec_setv2di;
  ena[598] = HAVE_vec_setv4sf;
  ena[599] = HAVE_vec_setv2df;
  ena[600] = HAVE_vec_shr_ti;
  ena[601] = HAVE_vec_shr_kf;
  ena[602] = HAVE_vec_shr_tf;
  ena[603] = HAVE_vec_shr_v16qi;
  ena[604] = HAVE_vec_shr_v8hi;
  ena[605] = HAVE_vec_shr_v4si;
  ena[606] = HAVE_vec_shr_v2di;
  ena[607] = HAVE_vec_shr_v1ti;
  ena[608] = HAVE_vec_shr_v4sf;
  ena[609] = HAVE_vec_shr_v2df;
  ena[610] = HAVE_vec_unpack_sfix_trunc_hi_v4sf;
  ena[611] = HAVE_vec_unpack_sfix_trunc_lo_v4sf;
  ena[612] = HAVE_vec_unpack_ufix_trunc_hi_v4sf;
  ena[613] = HAVE_vec_unpack_ufix_trunc_lo_v4sf;
  ena[614] = HAVE_vec_unpacks_float_hi_v8hi;
  ena[615] = HAVE_vec_unpacks_float_hi_v4si;
  ena[616] = HAVE_vec_unpacks_float_lo_v8hi;
  ena[617] = HAVE_vec_unpacks_float_lo_v4si;
  ena[618] = HAVE_vec_unpacks_hi_v16qi;
  ena[619] = HAVE_vec_unpacks_hi_v8hi;
  ena[620] = HAVE_vec_unpacks_hi_v4si;
  ena[621] = HAVE_vec_unpacks_hi_v4sf;
  ena[622] = HAVE_vec_unpacks_lo_v16qi;
  ena[623] = HAVE_vec_unpacks_lo_v8hi;
  ena[624] = HAVE_vec_unpacks_lo_v4si;
  ena[625] = HAVE_vec_unpacks_lo_v4sf;
  ena[626] = HAVE_vec_unpacku_float_hi_v8hi;
  ena[627] = HAVE_vec_unpacku_float_hi_v4si;
  ena[628] = HAVE_vec_unpacku_float_lo_v8hi;
  ena[629] = HAVE_vec_unpacku_float_lo_v4si;
  ena[630] = HAVE_vec_unpacku_hi_v16qi;
  ena[631] = HAVE_vec_unpacku_hi_v8hi;
  ena[632] = HAVE_vec_unpacku_hi_v4si;
  ena[633] = HAVE_vec_unpacku_lo_v16qi;
  ena[634] = HAVE_vec_unpacku_lo_v8hi;
  ena[635] = HAVE_vec_unpacku_lo_v4si;
  ena[636] = HAVE_vec_widen_smult_even_v16qi;
  ena[637] = HAVE_vec_widen_smult_even_v8hi;
  ena[638] = HAVE_vec_widen_smult_even_v4si;
  ena[639] = HAVE_vec_widen_smult_even_v2di;
  ena[640] = HAVE_vec_widen_smult_hi_v16qi;
  ena[641] = HAVE_vec_widen_smult_hi_v8hi;
  ena[642] = HAVE_vec_widen_smult_lo_v16qi;
  ena[643] = HAVE_vec_widen_smult_lo_v8hi;
  ena[644] = HAVE_vec_widen_smult_odd_v16qi;
  ena[645] = HAVE_vec_widen_smult_odd_v8hi;
  ena[646] = HAVE_vec_widen_smult_odd_v4si;
  ena[647] = HAVE_vec_widen_smult_odd_v2di;
  ena[648] = HAVE_vec_widen_umult_even_v16qi;
  ena[649] = HAVE_vec_widen_umult_even_v8hi;
  ena[650] = HAVE_vec_widen_umult_even_v4si;
  ena[651] = HAVE_vec_widen_umult_even_v2di;
  ena[652] = HAVE_vec_widen_umult_hi_v16qi;
  ena[653] = HAVE_vec_widen_umult_hi_v8hi;
  ena[654] = HAVE_vec_widen_umult_lo_v16qi;
  ena[655] = HAVE_vec_widen_umult_lo_v8hi;
  ena[656] = HAVE_vec_widen_umult_odd_v16qi;
  ena[657] = HAVE_vec_widen_umult_odd_v8hi;
  ena[658] = HAVE_vec_widen_umult_odd_v4si;
  ena[659] = HAVE_vec_widen_umult_odd_v2di;
  ena[660] = HAVE_atomic_add_fetchqi;
  ena[661] = HAVE_atomic_add_fetchhi;
  ena[662] = HAVE_atomic_add_fetchsi;
  ena[663] = HAVE_atomic_add_fetchdi;
  ena[664] = HAVE_atomic_add_fetchti;
  ena[665] = HAVE_atomic_addqi;
  ena[666] = HAVE_atomic_addhi;
  ena[667] = HAVE_atomic_addsi;
  ena[668] = HAVE_atomic_adddi;
  ena[669] = HAVE_atomic_addti;
  ena[670] = HAVE_atomic_and_fetchqi;
  ena[671] = HAVE_atomic_and_fetchhi;
  ena[672] = HAVE_atomic_and_fetchsi;
  ena[673] = HAVE_atomic_and_fetchdi;
  ena[674] = HAVE_atomic_and_fetchti;
  ena[675] = HAVE_atomic_andqi;
  ena[676] = HAVE_atomic_andhi;
  ena[677] = HAVE_atomic_andsi;
  ena[678] = HAVE_atomic_anddi;
  ena[679] = HAVE_atomic_andti;
  ena[680] = HAVE_atomic_compare_and_swapqi;
  ena[681] = HAVE_atomic_compare_and_swaphi;
  ena[682] = HAVE_atomic_compare_and_swapsi;
  ena[683] = HAVE_atomic_compare_and_swapdi;
  ena[684] = HAVE_atomic_compare_and_swapti;
  ena[685] = HAVE_atomic_exchangeqi;
  ena[686] = HAVE_atomic_exchangehi;
  ena[687] = HAVE_atomic_exchangesi;
  ena[688] = HAVE_atomic_exchangedi;
  ena[689] = HAVE_atomic_exchangeti;
  ena[690] = HAVE_atomic_fetch_addqi;
  ena[691] = HAVE_atomic_fetch_addhi;
  ena[692] = HAVE_atomic_fetch_addsi;
  ena[693] = HAVE_atomic_fetch_adddi;
  ena[694] = HAVE_atomic_fetch_addti;
  ena[695] = HAVE_atomic_fetch_andqi;
  ena[696] = HAVE_atomic_fetch_andhi;
  ena[697] = HAVE_atomic_fetch_andsi;
  ena[698] = HAVE_atomic_fetch_anddi;
  ena[699] = HAVE_atomic_fetch_andti;
  ena[700] = HAVE_atomic_fetch_nandqi;
  ena[701] = HAVE_atomic_fetch_nandhi;
  ena[702] = HAVE_atomic_fetch_nandsi;
  ena[703] = HAVE_atomic_fetch_nanddi;
  ena[704] = HAVE_atomic_fetch_nandti;
  ena[705] = HAVE_atomic_fetch_orqi;
  ena[706] = HAVE_atomic_fetch_orhi;
  ena[707] = HAVE_atomic_fetch_orsi;
  ena[708] = HAVE_atomic_fetch_ordi;
  ena[709] = HAVE_atomic_fetch_orti;
  ena[710] = HAVE_atomic_fetch_subqi;
  ena[711] = HAVE_atomic_fetch_subhi;
  ena[712] = HAVE_atomic_fetch_subsi;
  ena[713] = HAVE_atomic_fetch_subdi;
  ena[714] = HAVE_atomic_fetch_subti;
  ena[715] = HAVE_atomic_fetch_xorqi;
  ena[716] = HAVE_atomic_fetch_xorhi;
  ena[717] = HAVE_atomic_fetch_xorsi;
  ena[718] = HAVE_atomic_fetch_xordi;
  ena[719] = HAVE_atomic_fetch_xorti;
  ena[720] = HAVE_atomic_loadqi;
  ena[721] = HAVE_atomic_loadhi;
  ena[722] = HAVE_atomic_loadsi;
  ena[723] = HAVE_atomic_loaddi;
  ena[724] = HAVE_atomic_loadti;
  ena[725] = HAVE_atomic_nand_fetchqi;
  ena[726] = HAVE_atomic_nand_fetchhi;
  ena[727] = HAVE_atomic_nand_fetchsi;
  ena[728] = HAVE_atomic_nand_fetchdi;
  ena[729] = HAVE_atomic_nand_fetchti;
  ena[730] = HAVE_atomic_nandqi;
  ena[731] = HAVE_atomic_nandhi;
  ena[732] = HAVE_atomic_nandsi;
  ena[733] = HAVE_atomic_nanddi;
  ena[734] = HAVE_atomic_nandti;
  ena[735] = HAVE_atomic_or_fetchqi;
  ena[736] = HAVE_atomic_or_fetchhi;
  ena[737] = HAVE_atomic_or_fetchsi;
  ena[738] = HAVE_atomic_or_fetchdi;
  ena[739] = HAVE_atomic_or_fetchti;
  ena[740] = HAVE_atomic_orqi;
  ena[741] = HAVE_atomic_orhi;
  ena[742] = HAVE_atomic_orsi;
  ena[743] = HAVE_atomic_ordi;
  ena[744] = HAVE_atomic_orti;
  ena[745] = HAVE_atomic_storeqi;
  ena[746] = HAVE_atomic_storehi;
  ena[747] = HAVE_atomic_storesi;
  ena[748] = HAVE_atomic_storedi;
  ena[749] = HAVE_atomic_storeti;
  ena[750] = HAVE_atomic_sub_fetchqi;
  ena[751] = HAVE_atomic_sub_fetchhi;
  ena[752] = HAVE_atomic_sub_fetchsi;
  ena[753] = HAVE_atomic_sub_fetchdi;
  ena[754] = HAVE_atomic_sub_fetchti;
  ena[755] = HAVE_atomic_subqi;
  ena[756] = HAVE_atomic_subhi;
  ena[757] = HAVE_atomic_subsi;
  ena[758] = HAVE_atomic_subdi;
  ena[759] = HAVE_atomic_subti;
  ena[760] = HAVE_atomic_xor_fetchqi;
  ena[761] = HAVE_atomic_xor_fetchhi;
  ena[762] = HAVE_atomic_xor_fetchsi;
  ena[763] = HAVE_atomic_xor_fetchdi;
  ena[764] = HAVE_atomic_xor_fetchti;
  ena[765] = HAVE_atomic_xorqi;
  ena[766] = HAVE_atomic_xorhi;
  ena[767] = HAVE_atomic_xorsi;
  ena[768] = HAVE_atomic_xordi;
  ena[769] = HAVE_atomic_xorti;
  ena[770] = HAVE_len_load_v16qi;
  ena[771] = HAVE_len_store_v16qi;
}

/* Returns TRUE if the target supports any of the partial vector
   optabs: while_ult_optab, len_load_optab or len_store_optab,
   for any mode.  */
bool
partial_vectors_supported_p (void)
{
	return HAVE_len_load_v16qi || HAVE_len_store_v16qi;
}
static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  VEC_DUPLICATE,
  VEC_SERIES,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  unknown_optab,
  unknown_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  vec_duplicate_optab,
  vec_series_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

